Bug 31172 - Uri parsing exceptions when username or password has space in it
Summary: Uri parsing exceptions when username or password has space in it
Status: RESOLVED FIXED
Alias: None
Product: Class Libraries
Classification: Mono
Component: mscorlib (show other bugs)
Version: 4.0.0
Hardware: PC Windows
: --- normal
Target Milestone: Untriaged
Assignee: marcos.henrich
URL:
Depends on:
Blocks:
 
Reported: 2015-06-16 17:17 UTC by me
Modified: 2015-09-04 02:43 UTC (History)
2 users (show)

See Also:
Tags:
Is this bug a regression?: ---
Last known good build:


Attachments

Description me 2015-06-16 17:17:27 UTC
Following code works perfectly fine in .Net 4.5 on Windows:

using System;

public class Program
{
        public static void Main()
        {
                const string url = "rtmp://test 1:pass 1@test.com:333/live";
                var uri = new Uri(url);
                Console.WriteLine(uri.AbsoluteUri);
        }
}


On running in mono 4.0.1 on Ubuntu I get 

System.UriFormatException: Invalid URI: The hostname could not be parsed.
  at System.Uri.Parse (UriKind kind, System.String uriString) [0x00000] in <filename unknown>:0
  at System.Uri.ParseUri (UriKind kind) [0x00000] in <filename unknown>:0
  at System.Uri..ctor (System.String uriString, Boolean dontEscape) [0x00000] in <filename unknown>:0
  at System.Uri..ctor (System.String uriString) [0x00000] in <filename unknown>:0
  at Program.Main () [0x00000] in <filename unknown>:0
[ERROR] FATAL UNHANDLED EXCEPTION: System.UriFormatException: Invalid URI: The hostname could not be parsed.
  at System.Uri.Parse (UriKind kind, System.String uriString) [0x00000] in <filename unknown>:0
  at System.Uri.ParseUri (UriKind kind) [0x00000] in <filename unknown>:0
  at System.Uri..ctor (System.String uriString, Boolean dontEscape) [0x00000] in <filename unknown>:0
  at System.Uri..ctor (System.String uriString) [0x00000] in <filename unknown>:0
  at Program.Main () [0x00000] in <filename unknown>:0
Comment 1 marcos.henrich 2015-09-04 00:46:40 UTC
Hi mshapiro,

Thank you for the bug report.

The issue should be fixed by https://github.com/mono/mono/pull/2030.
Comment 2 marcos.henrich 2015-09-04 02:43:06 UTC
Fixed in master a8f85e720ea22b64380c06bb2493ccbade6a0e2e.
https://github.com/mono/mono/commit/a8f85e720ea22b64380c06bb2493ccbade6a0e2e

Notice (2018-05-21): bugzilla.xamarin.com will be switching to read-only mode on Thursday, 2018-05-25 22:00 UTC.

Please join us on Visual Studio Developer Community and GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs and copy them to the new locations as needed for follow-up. The See Also field on each Bugzilla bug will be updated with a link to its new location when applicable.

After Bugzilla is read-only, if you have new information to add for a bug that does not yet have a matching issue on Developer Community or GitHub, you can create a follow-up issue in the new location. Copy and paste the title and description from this bug, and then add your new details. You can get a pre-formatted version of the title and description here:

In special cases you might also want the comments:

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Note You need to log in before you can comment on or make changes to this bug.